with Ada.Text_IO;             use Ada.Text_IO; 
with Ada.Integer_Text_IO;     use Ada.Integer_Text_IO;
with Ada.Strings.Fixed; use Ada.Strings.Fixed;
with chaines; use chaines;


procedure manipuler_chaine is

   type T_Menu is (Rechercher, Remplacer_1, Remplacer_2, Quitter); -- Pour pouvoir afficher le menu
   package ES_menu is new Enumeration_IO(T_Menu); use ES_menu;
   
   ------------ Specifications -----------------------
   function Menu return T_Menu;
   procedure Presentation;
   procedure Afficher;
   
  -----------------------------------------------------------------------------
  -- Nom         : Presentation                                                                             
  -- But         :  
  -- Parametres  :                      
  -----------------------------------------------------------------------------
  procedure Presentation is 
  begin -- Presentation
	 Put_line("****************************************************************");
	 Put_Line("*                                                              *");
     Put_Line("* Programme qui permet de manipuler des chaines de caractres  *");
     Put_Line("*                                                              *");
     Put_line("****************************************************************");
  end Presentation;


  ----------------------------------------------------------------------------
  -- Nom         : Afficher                                                                             
  -- But         : Afficher le menu ci-dessous
  -- 	New_Line;
  -- 	Put_Line(" ***** Quelle operation desirez vous effectuer *******");
  -- 	Put_Line(" *                                                   *");
  -- 	Put_Line(" *  Rechercher     -----------------------------------: 1 *");
  -- 	Put_Line(" *  Remplacer -----------------------------------: 2 *");
  -- 	Put_Line(" *  Quitter -------------------------------------: 3 *");
  -- 	Put_Line(" *                                                   *");
  -- 	Put_Line(" *****************************************************"); 
  --    New_line;
  -----------------------------------------------------------------------------
  procedure Afficher is
  begin
	 New_Line;
	 Put_Line("    ******* Quelle operation desirez vous effectuer *******");
	 New_Line;
      for Menu in T_Menu loop
        Put("       ");
        Put(Menu, T_Menu'Width);
        Put(" -------------------------------  ");
        Put(T_Menu'Pos(Menu)+1, 0);
        New_Line;
      end loop;
    New_Line;
	 Put_Line("    ********************************************************"); 
    New_line;
  end Afficher;

   ----------------------------------------------------------------------------
   -- Nom         : Menu                                                                             
   -- But         :  
   -- Parametres  : 
   -- Exception   :                     
   -----------------------------------------------------------------------------
  function Menu return T_Menu is
     subtype T_Choix is Positive range T_Menu'Pos(T_Menu'First)+1..T_Menu'Pos(T_Menu'Last)+1;
     Choix : T_Choix;
  begin -- Menu
      Afficher;
	   Put(" Saisir votre Choix : ");
	   loop
    	   begin
		     Get(Choix);
		     New_Line(2);
		     Skip_Line;
		     return T_Menu'Val(Choix-1);		
	        exception
		     when Data_Error | Constraint_Error=>
                                     Skip_line; New_line;
		     Put_Line(" Saisie incorrecte");
		     Put(" Veuillez entrez une nouvelle valeur: ");
	      end;
   	end loop;
   end Menu;
 --------------------------------------------------------------------------
 
 
a:natural;
   Choix : T_Menu;		-- choix de l'utilisateur

begin --
  Presentation;		-- appel de la fonction presentation
  loop
 	  begin
	      Choix := Menu;  	-- appel de la fonction Menu

	      case Choix is
		         when T_Menu'(Rechercher)     => Put_line("recherche de 'tu' dans 'voiture'");
												a:=Indice_De("tu","voiture");
												Put_Line("Cette occurence est  la position " & natural'image(a));
												new_line(2);delay 0.5;
												Put_line("recherche de 'tu' dans 'bazooka'");
												a:=Indice_De("tu","bazooka");
												If a =0 then Put_Line("Pas d'occurence "); end if;
												delay 0.5; 
												skip_line;
												
		         when T_Menu'(Remplacer_1) => Put_line("remplacement de 'tu' dans 'voiture' par 'bi'");delay 0.5;
											Put_line(Remplacement("tu","bi","voiture"));
											New_line(2);delay 0.5;
											Put_line("remplacement de 'tu' dans 'voiture' par 'ci l'heu'");delay 0.5;
											Put_line(Remplacement("tu","ci l'heu","voiture"));
											New_line(2);delay 0.5;skip_line;
												
				when T_Menu'(Remplacer_2) => Put_line("remplacement de 'mal' dans 'malheur' par 'bon'");delay 0.5;
											Put_line(Remplacement("mal","bon","malheur"));
											New_line(2);delay 0.5;
											Put_line("remplacement de 'tu' dans 'bazooka' par 'bi'");delay 0.5;
											Put_line(Remplacement("tu","bi","bazooka"));
											New_line(2);delay 0.5;skip_line;
				 
		         when T_Menu'(Quitter)   =>  exit;		  
		  end case;
	  

exception
	when Longueur_diff =>
		Put_Line("Remplacement impossible : les chaines sont de tailles diffrentes");
	when Pas_occ =>
		Put_Line("Remplacement impossible : la chaine " & "'De'" & " n'est pas prsente dans la chaine " & "'Dans'");
	end;	
	end loop;

end manipuler_chaine;